import java.util.*;

public class Sample {
  public static List<Person> createPeople() {
    return List.of(
      new Person("Sara", 20),
      new Person("Bob", 20),
      new Person("Sara", 20),
      new Person("Paul", 32),
      new Person("Paula", 32),
      new Person("Jack", 2),
      new Person("Jack", 72),
      new Person("Pete", 35)
    );
  }

  public static void main(String[] args) {
    //var totalOfAges = createPeople().stream()
    //  .map(Person::getAge)
    //  .sum(); //ERROR

    var totalOfAges = createPeople().stream()
      .mapToInt(Person::getAge)
      .sum();

    System.out.println(totalOfAges);
  }
}

//Stream<T> does not have a sum method, but IntStream, LongStream, etc. have sum. mapToInt converts Stream<T> to an IntStream.

//sum is a specialized reduce operation

