import java.util.*;
import static java.util.stream.Collectors.*;

public class Sample {
  public static List<Person> createPeople() {
    return List.of(
      new Person("Sara", 20),
      new Person("Bob", 20),
      new Person("Sara", 20),
      new Person("Paul", 32),
      new Person("Paula", 32),
      new Person("Jack", 2),
      new Person("Jack", 72),
      new Person("Pete", 35)
    );
  }

  public static void main(String[] args) {
    var result1 = createPeople().stream()
      .filter(person -> person.getAge() > 30)
      .collect(groupingBy(Person::getName));

    System.out.println(result1);

    //if we want to see all the name in the output, but only
    //the objects where age > 30 in the value list, then how?

    var result2 = createPeople().stream()
      .collect(groupingBy(Person::getName,
        filtering(person -> person.getAge() > 30, toList())));

    System.out.println(result2);
  }
}

